/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.ergebnis;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.ergebnis.boundary.AbstractDHondtQuotientPolitischeGruppeSearchParameters;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientPolitischeGruppeChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientPolitischeGruppeConversationStore;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientPolitischeGruppeExtendedDAO;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientPolitischeGruppeSearch;
import de.ivu.elect.business.ergebnis.boundary.DHondtQuotientPolitischeGruppeSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientPolitischeGruppe;
import de.ivu.elect.business.ergebnis.entity.DHondtQuotientPolitischeGruppeMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDHondtQuotientPolitischeGruppeSearchView.COMPONENT_NAME)
@View(viewId = AbstractDHondtQuotientPolitischeGruppeSearchView.VIEW_ID, useCase = UseCasePermission.D_H_QU_POLITISCHE_GRUPPE_SEARCH)
public abstract class AbstractDHondtQuotientPolitischeGruppeSearchView extends AbstractElectSearchView<DHondtQuotientPolitischeGruppe> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dHondtQuotientPolitischeGruppeSearchView";
  
  public static final String VIEW_ID = "/ergebnis/d-hondt-quotient-politische-gruppe-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDHondtQuotientPolitischeGruppeSearchView requestHandler;

  @Inject
  private transient DHondtQuotientPolitischeGruppeExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DHondtQuotientPolitischeGruppeConversationStore.class)
  protected transient DHondtQuotientPolitischeGruppeConversationStore conversationStore;

  @Inject
  protected transient DHondtQuotientPolitischeGruppeSearch search;

  @Inject
  @ConversationGroup(AbstractDHondtQuotientPolitischeGruppeSearchParameters.class)
  protected transient DHondtQuotientPolitischeGruppeSearchParameters searchParameters;

  @Inject
  protected transient DHondtQuotientPolitischeGruppeMeta entityMeta;

  public AbstractDHondtQuotientPolitischeGruppeSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public DHondtQuotientPolitischeGruppe getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(DHondtQuotientPolitischeGruppe entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DHondtQuotientPolitischeGruppeSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<DHondtQuotientPolitischeGruppe> getEagerLoadingCollector() {
    return EagerLoadingCollector.<DHondtQuotientPolitischeGruppe> create();
  }

  @Override
  public List<DHondtQuotientPolitischeGruppe> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<DHondtQuotientPolitischeGruppe> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDHondtQuotientPolitischeGruppeChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DHondtQuotientPolitischeGruppeChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDHondtQuotientPolitischeGruppeSearchView {

    @View
    @Inject
    private transient Instance<AbstractDHondtQuotientPolitischeGruppeSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDHondtQuotientPolitischeGruppeSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
